<html>
<head>
<title>OgreMeshFileFormat.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreMeshFileFormat.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreMeshFileFormat_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __MeshFileFormat_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __MeshFileFormat_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>Ogre {
<a name="l00034"></a>00034 
<a name="l00058"></a><a class="code" href="group__Resources.html#ga7b904fc5463a8ef1e61f6de39b603fc4">00058</a>     <span class="keyword">enum</span> <a class="code" href="group__Resources.html#ga7b904fc5463a8ef1e61f6de39b603fc4" title="Definition of the OGRE .mesh file format.">MeshChunkID</a> {
<a name="l00059"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4ae377c85390fc6c2cb7d57009bbcb48a3">00059</a>         <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4ae377c85390fc6c2cb7d57009bbcb48a3">M_HEADER</a>                = 0x1000,
<a name="l00060"></a>00060             <span class="comment">// char*          version           : Version number check</span>
<a name="l00061"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a7e30f93c634e73eccf5841247edcf394">00061</a>         <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a7e30f93c634e73eccf5841247edcf394">M_MESH</a>                = 0x3000,
<a name="l00062"></a>00062             <span class="comment">// bool skeletallyAnimated   // important flag which affects h/w buffer policies</span>
<a name="l00063"></a>00063             <span class="comment">// Optional M_GEOMETRY chunk</span>
<a name="l00064"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a2ea0d2c7c324fa5745b325a9e1c4cbb8">00064</a>             <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a2ea0d2c7c324fa5745b325a9e1c4cbb8">M_SUBMESH</a>             = 0x4000, 
<a name="l00065"></a>00065                 <span class="comment">// char* materialName</span>
<a name="l00066"></a>00066                 <span class="comment">// bool useSharedVertices</span>
<a name="l00067"></a>00067                 <span class="comment">// unsigned int indexCount</span>
<a name="l00068"></a>00068                 <span class="comment">// bool indexes32Bit</span>
<a name="l00069"></a>00069                 <span class="comment">// unsigned int* faceVertexIndices (indexCount)</span>
<a name="l00070"></a>00070                 <span class="comment">// OR</span>
<a name="l00071"></a>00071                 <span class="comment">// unsigned short* faceVertexIndices (indexCount)</span>
<a name="l00072"></a>00072                 <span class="comment">// M_GEOMETRY chunk (Optional: present only if useSharedVertices = false)</span>
<a name="l00073"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a204c8cf7adc882832f720fec814b3736">00073</a>                 <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a204c8cf7adc882832f720fec814b3736">M_SUBMESH_OPERATION</a> = 0x4010, <span class="comment">// optional, trilist assumed if missing</span>
<a name="l00074"></a>00074                     <span class="comment">// unsigned short operationType</span>
<a name="l00075"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a0be59b8913a5cb6a92942172121a1feb">00075</a>                 <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a0be59b8913a5cb6a92942172121a1feb">M_SUBMESH_BONE_ASSIGNMENT</a> = 0x4100,
<a name="l00076"></a>00076                     <span class="comment">// Optional bone weights (repeating section)</span>
<a name="l00077"></a>00077                     <span class="comment">// unsigned int vertexIndex;</span>
<a name="l00078"></a>00078                     <span class="comment">// unsigned short boneIndex;</span>
<a name="l00079"></a>00079                     <span class="comment">// float weight;</span>
<a name="l00080"></a>00080                 <span class="comment">// Optional chunk that matches a texture name to an alias</span>
<a name="l00081"></a>00081                 <span class="comment">// a texture alias is sent to the submesh material to use this texture name</span>
<a name="l00082"></a>00082                 <span class="comment">// instead of the one in the texture unit with a matching alias name</span>
<a name="l00083"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a36e136a0ae3018f1bdb14cb8ee355b2a">00083</a>                 <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a36e136a0ae3018f1bdb14cb8ee355b2a">M_SUBMESH_TEXTURE_ALIAS</a> = 0x4200, <span class="comment">// Repeating section</span>
<a name="l00084"></a>00084                     <span class="comment">// char* aliasName;</span>
<a name="l00085"></a>00085                     <span class="comment">// char* textureName;</span>
<a name="l00086"></a>00086 
<a name="l00087"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4ab58cc7791a7fced01dfb77b38f804750">00087</a>             <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4ab58cc7791a7fced01dfb77b38f804750">M_GEOMETRY</a>          = 0x5000, <span class="comment">// NB this chunk is embedded within M_MESH and M_SUBMESH</span>
<a name="l00088"></a>00088                 <span class="comment">// unsigned int vertexCount</span>
<a name="l00089"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a529e87421877a2c003b001e99a2a1ec3">00089</a>                 <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a529e87421877a2c003b001e99a2a1ec3">M_GEOMETRY_VERTEX_DECLARATION</a> = 0x5100,
<a name="l00090"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4ac094ecf94bea8aabc8e50913260ca01a">00090</a>                     <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4ac094ecf94bea8aabc8e50913260ca01a">M_GEOMETRY_VERTEX_ELEMENT</a> = 0x5110, <span class="comment">// Repeating section</span>
<a name="l00091"></a>00091                         <span class="comment">// unsigned short source;   // buffer bind source</span>
<a name="l00092"></a>00092                         <span class="comment">// unsigned short type;     // VertexElementType</span>
<a name="l00093"></a>00093                         <span class="comment">// unsigned short semantic; // VertexElementSemantic</span>
<a name="l00094"></a>00094                         <span class="comment">// unsigned short offset;   // start offset in buffer in bytes</span>
<a name="l00095"></a>00095                         <span class="comment">// unsigned short index;    // index of the semantic (for colours and texture coords)</span>
<a name="l00096"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4ae8e03368ae266d871c8bee40fc9b2884">00096</a>                 <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4ae8e03368ae266d871c8bee40fc9b2884">M_GEOMETRY_VERTEX_BUFFER</a> = 0x5200, <span class="comment">// Repeating section</span>
<a name="l00097"></a>00097                     <span class="comment">// unsigned short bindIndex;    // Index to bind this buffer to</span>
<a name="l00098"></a>00098                     <span class="comment">// unsigned short vertexSize;   // Per-vertex size, must agree with declaration at this index</span>
<a name="l00099"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4ab6b7146d2e47408f325e5d95f52d1360">00099</a>                     <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4ab6b7146d2e47408f325e5d95f52d1360">M_GEOMETRY_VERTEX_BUFFER_DATA</a> = 0x5210,
<a name="l00100"></a>00100                         <span class="comment">// raw buffer data</span>
<a name="l00101"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a061bd3bd94e92d0d31a76b1030d28a8b">00101</a>             <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a061bd3bd94e92d0d31a76b1030d28a8b">M_MESH_SKELETON_LINK</a> = 0x6000,
<a name="l00102"></a>00102                 <span class="comment">// Optional link to skeleton</span>
<a name="l00103"></a>00103                 <span class="comment">// char* skeletonName           : name of .skeleton to use</span>
<a name="l00104"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a5a2466fdd447d7a91aad57a941cbd336">00104</a>             <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a5a2466fdd447d7a91aad57a941cbd336">M_MESH_BONE_ASSIGNMENT</a> = 0x7000,
<a name="l00105"></a>00105                 <span class="comment">// Optional bone weights (repeating section)</span>
<a name="l00106"></a>00106                 <span class="comment">// unsigned int vertexIndex;</span>
<a name="l00107"></a>00107                 <span class="comment">// unsigned short boneIndex;</span>
<a name="l00108"></a>00108                 <span class="comment">// float weight;</span>
<a name="l00109"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4abe24a7ed8a68168e01d8f355f9924356">00109</a>             <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4abe24a7ed8a68168e01d8f355f9924356">M_MESH_LOD</a> = 0x8000,
<a name="l00110"></a>00110                 <span class="comment">// Optional LOD information</span>
<a name="l00111"></a>00111                 <span class="comment">// string strategyName;</span>
<a name="l00112"></a>00112                 <span class="comment">// unsigned short numLevels;</span>
<a name="l00113"></a>00113                 <span class="comment">// bool manual;  (true for manual alternate meshes, false for generated)</span>
<a name="l00114"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a91d18ad3575494d5723187a27c0554ad">00114</a>                 <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a91d18ad3575494d5723187a27c0554ad">M_MESH_LOD_USAGE</a> = 0x8100,
<a name="l00115"></a>00115                 <span class="comment">// Repeating section, ordered in increasing depth</span>
<a name="l00116"></a>00116                 <span class="comment">// NB LOD 0 (full detail from 0 depth) is omitted</span>
<a name="l00117"></a>00117                 <span class="comment">// LOD value - this is a distance, a pixel count etc, based on strategy</span>
<a name="l00118"></a>00118                 <span class="comment">// float lodValue;</span>
<a name="l00119"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4aa70c05306a33c122ff87a48135ebff9f">00119</a>                     <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4aa70c05306a33c122ff87a48135ebff9f">M_MESH_LOD_MANUAL</a> = 0x8110,
<a name="l00120"></a>00120                     <span class="comment">// Required if M_MESH_LOD section manual = true</span>
<a name="l00121"></a>00121                     <span class="comment">// String manualMeshName;</span>
<a name="l00122"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4ab2e273eb42a551fce6fcedc23b1b5579">00122</a>                     <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4ab2e273eb42a551fce6fcedc23b1b5579">M_MESH_LOD_GENERATED</a> = 0x8120,
<a name="l00123"></a>00123                     <span class="comment">// Required if M_MESH_LOD section manual = false</span>
<a name="l00124"></a>00124                     <span class="comment">// Repeating section (1 per submesh)</span>
<a name="l00125"></a>00125                     <span class="comment">// unsigned int indexCount;</span>
<a name="l00126"></a>00126                     <span class="comment">// bool indexes32Bit</span>
<a name="l00127"></a>00127                     <span class="comment">// unsigned short* faceIndexes;  (indexCount)</span>
<a name="l00128"></a>00128                     <span class="comment">// OR</span>
<a name="l00129"></a>00129                     <span class="comment">// unsigned int* faceIndexes;  (indexCount)</span>
<a name="l00130"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a1516dd9026781cc83396590e73eb5bd2">00130</a>             <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a1516dd9026781cc83396590e73eb5bd2">M_MESH_BOUNDS</a> = 0x9000,
<a name="l00131"></a>00131                 <span class="comment">// float minx, miny, minz</span>
<a name="l00132"></a>00132                 <span class="comment">// float maxx, maxy, maxz</span>
<a name="l00133"></a>00133                 <span class="comment">// float radius</span>
<a name="l00134"></a>00134                     
<a name="l00135"></a>00135             <span class="comment">// Added By DrEvil</span>
<a name="l00136"></a>00136             <span class="comment">// optional chunk that contains a table of submesh indexes and the names of</span>
<a name="l00137"></a>00137             <span class="comment">// the sub-meshes.</span>
<a name="l00138"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a53de3dbb8a1fb4199fecfcc13b99a780">00138</a>             <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a53de3dbb8a1fb4199fecfcc13b99a780">M_SUBMESH_NAME_TABLE</a> = 0xA000,
<a name="l00139"></a>00139                 <span class="comment">// Subchunks of the name table. Each chunk contains an index &amp; string</span>
<a name="l00140"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4ad2d5c64333e75efb676c25cf7413fbe7">00140</a>                 <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4ad2d5c64333e75efb676c25cf7413fbe7">M_SUBMESH_NAME_TABLE_ELEMENT</a> = 0xA100,
<a name="l00141"></a>00141                     <span class="comment">// short index</span>
<a name="l00142"></a>00142                     <span class="comment">// char* name</span>
<a name="l00143"></a>00143             
<a name="l00144"></a>00144             <span class="comment">// Optional chunk which stores precomputed edge data                     </span>
<a name="l00145"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a9702b7e52d4ea26c0eaffe49a2ea3fca">00145</a>             <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a9702b7e52d4ea26c0eaffe49a2ea3fca">M_EDGE_LISTS</a> = 0xB000,
<a name="l00146"></a>00146                 <span class="comment">// Each LOD has a separate edge list</span>
<a name="l00147"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a85ec2f21278624525b12aae23fecd8a3">00147</a>                 <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a85ec2f21278624525b12aae23fecd8a3">M_EDGE_LIST_LOD</a> = 0xB100,
<a name="l00148"></a>00148                     <span class="comment">// unsigned short lodIndex</span>
<a name="l00149"></a>00149                     <span class="comment">// bool isManual            // If manual, no edge data here, loaded from manual mesh</span>
<a name="l00150"></a>00150                         <span class="comment">// bool isClosed</span>
<a name="l00151"></a>00151                         <span class="comment">// unsigned long numTriangles</span>
<a name="l00152"></a>00152                         <span class="comment">// unsigned long numEdgeGroups</span>
<a name="l00153"></a>00153                         <span class="comment">// Triangle* triangleList</span>
<a name="l00154"></a>00154                             <span class="comment">// unsigned long indexSet</span>
<a name="l00155"></a>00155                             <span class="comment">// unsigned long vertexSet</span>
<a name="l00156"></a>00156                             <span class="comment">// unsigned long vertIndex[3]</span>
<a name="l00157"></a>00157                             <span class="comment">// unsigned long sharedVertIndex[3] </span>
<a name="l00158"></a>00158                             <span class="comment">// float normal[4] </span>
<a name="l00159"></a>00159 
<a name="l00160"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a57ce1f8065af27bbbe84c1525b2541cb">00160</a>                         <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a57ce1f8065af27bbbe84c1525b2541cb">M_EDGE_GROUP</a> = 0xB110,
<a name="l00161"></a>00161                             <span class="comment">// unsigned long vertexSet</span>
<a name="l00162"></a>00162                             <span class="comment">// unsigned long triStart</span>
<a name="l00163"></a>00163                             <span class="comment">// unsigned long triCount</span>
<a name="l00164"></a>00164                             <span class="comment">// unsigned long numEdges</span>
<a name="l00165"></a>00165                             <span class="comment">// Edge* edgeList</span>
<a name="l00166"></a>00166                                 <span class="comment">// unsigned long  triIndex[2]</span>
<a name="l00167"></a>00167                                 <span class="comment">// unsigned long  vertIndex[2]</span>
<a name="l00168"></a>00168                                 <span class="comment">// unsigned long  sharedVertIndex[2]</span>
<a name="l00169"></a>00169                                 <span class="comment">// bool degenerate</span>
<a name="l00170"></a>00170 
<a name="l00171"></a>00171             <span class="comment">// Optional poses section, referred to by pose keyframes</span>
<a name="l00172"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a8f20b9f53c4a616ebb80d5f5e6dce6f2">00172</a>             <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a8f20b9f53c4a616ebb80d5f5e6dce6f2">M_POSES</a> = 0xC000,
<a name="l00173"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4adb5976001d45fa25b6f5bf094ee26cb9">00173</a>                 <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4adb5976001d45fa25b6f5bf094ee26cb9">M_POSE</a> = 0xC100,
<a name="l00174"></a>00174                     <span class="comment">// char* name (may be blank)</span>
<a name="l00175"></a>00175                     <span class="comment">// unsigned short target    // 0 for shared geometry, </span>
<a name="l00176"></a>00176                                                 <span class="comment">// 1+ for submesh index + 1</span>
<a name="l00177"></a>00177                     <span class="comment">// bool includesNormals [1.8+]</span>
<a name="l00178"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a1c05dca2e153c0546074b2361706d4d0">00178</a>                     <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a1c05dca2e153c0546074b2361706d4d0">M_POSE_VERTEX</a> = 0xC111,
<a name="l00179"></a>00179                         <span class="comment">// unsigned long vertexIndex</span>
<a name="l00180"></a>00180                         <span class="comment">// float xoffset, yoffset, zoffset</span>
<a name="l00181"></a>00181                         <span class="comment">// float xnormal, ynormal, znormal (optional, 1.8+)</span>
<a name="l00182"></a>00182             <span class="comment">// Optional vertex animation chunk</span>
<a name="l00183"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a47ebdc0a3d866f96d1272b53c956d60a">00183</a>             <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a47ebdc0a3d866f96d1272b53c956d60a">M_ANIMATIONS</a> = 0xD000, 
<a name="l00184"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a20cea2365d30a7aad8f79ca58f058b50">00184</a>                 <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a20cea2365d30a7aad8f79ca58f058b50">M_ANIMATION</a> = 0xD100,
<a name="l00185"></a>00185                 <span class="comment">// char* name</span>
<a name="l00186"></a>00186                 <span class="comment">// float length</span>
<a name="l00187"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a079f2868b05b6ee086bba76454a925df">00187</a>                 <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a079f2868b05b6ee086bba76454a925df">M_ANIMATION_BASEINFO</a> = 0xD105,
<a name="l00188"></a>00188                 <span class="comment">// [Optional] base keyframe information (pose animation only)</span>
<a name="l00189"></a>00189                 <span class="comment">// char* baseAnimationName (blank for self)</span>
<a name="l00190"></a>00190                 <span class="comment">// float baseKeyFrameTime</span>
<a name="l00191"></a>00191         
<a name="l00192"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a06f1e8f333e075e3c50c1d6857423a3c">00192</a>                 <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a06f1e8f333e075e3c50c1d6857423a3c">M_ANIMATION_TRACK</a> = 0xD110,
<a name="l00193"></a>00193                     <span class="comment">// unsigned short type          // 1 == morph, 2 == pose</span>
<a name="l00194"></a>00194                     <span class="comment">// unsigned short target        // 0 for shared geometry, </span>
<a name="l00195"></a>00195                                                     <span class="comment">// 1+ for submesh index + 1</span>
<a name="l00196"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a4227a01f9308f161b1dff36d37bfca1f">00196</a>                     <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a4227a01f9308f161b1dff36d37bfca1f">M_ANIMATION_MORPH_KEYFRAME</a> = 0xD111,
<a name="l00197"></a>00197                         <span class="comment">// float time</span>
<a name="l00198"></a>00198                         <span class="comment">// bool includesNormals [1.8+]</span>
<a name="l00199"></a>00199                         <span class="comment">// float x,y,z          // repeat by number of vertices in original geometry</span>
<a name="l00200"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a1530b8d3112bec8376a066db1859820d">00200</a>                     <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a1530b8d3112bec8376a066db1859820d">M_ANIMATION_POSE_KEYFRAME</a> = 0xD112,
<a name="l00201"></a>00201                         <span class="comment">// float time</span>
<a name="l00202"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a01f246a4298151dc5b2271de6bf19acc">00202</a>                         <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a01f246a4298151dc5b2271de6bf19acc">M_ANIMATION_POSE_REF</a> = 0xD113, <span class="comment">// repeat for number of referenced poses</span>
<a name="l00203"></a>00203                             <span class="comment">// unsigned short poseIndex </span>
<a name="l00204"></a>00204                             <span class="comment">// float influence</span>
<a name="l00205"></a>00205 
<a name="l00206"></a>00206             <span class="comment">// Optional submesh extreme vertex list chink</span>
<a name="l00207"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4adef65eae91dcd6082bbc4be1bf0d950e">00207</a>             <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4adef65eae91dcd6082bbc4be1bf0d950e">M_TABLE_EXTREMES</a> = 0xE000,
<a name="l00208"></a>00208             <span class="comment">// unsigned short submesh_index;</span>
<a name="l00209"></a>00209             <span class="comment">// float extremes [n_extremes][3];</span>
<a name="l00210"></a>00210 
<a name="l00211"></a>00211     <span class="comment">/* Version 1.2 of the .mesh format (deprecated)</span>
<a name="l00212"></a>00212 <span class="comment">    enum MeshChunkID {</span>
<a name="l00213"></a>00213 <span class="comment">        M_HEADER                = 0x1000,</span>
<a name="l00214"></a>00214 <span class="comment">            // char*          version           : Version number check</span>
<a name="l00215"></a>00215 <span class="comment">        M_MESH                = 0x3000,</span>
<a name="l00216"></a>00216 <span class="comment">            // bool skeletallyAnimated   // important flag which affects h/w buffer policies</span>
<a name="l00217"></a>00217 <span class="comment">            // Optional M_GEOMETRY chunk</span>
<a name="l00218"></a>00218 <span class="comment">            M_SUBMESH             = 0x4000, </span>
<a name="l00219"></a>00219 <span class="comment">                // char* materialName</span>
<a name="l00220"></a>00220 <span class="comment">                // bool useSharedVertices</span>
<a name="l00221"></a>00221 <span class="comment">                // unsigned int indexCount</span>
<a name="l00222"></a>00222 <span class="comment">                // bool indexes32Bit</span>
<a name="l00223"></a>00223 <span class="comment">                // unsigned int* faceVertexIndices (indexCount)</span>
<a name="l00224"></a>00224 <span class="comment">                // OR</span>
<a name="l00225"></a>00225 <span class="comment">                // unsigned short* faceVertexIndices (indexCount)</span>
<a name="l00226"></a>00226 <span class="comment">                // M_GEOMETRY chunk (Optional: present only if useSharedVertices = false)</span>
<a name="l00227"></a>00227 <span class="comment">                M_SUBMESH_OPERATION = 0x4010, // optional, trilist assumed if missing</span>
<a name="l00228"></a>00228 <span class="comment">                    // unsigned short operationType</span>
<a name="l00229"></a>00229 <span class="comment">                M_SUBMESH_BONE_ASSIGNMENT = 0x4100,</span>
<a name="l00230"></a>00230 <span class="comment">                    // Optional bone weights (repeating section)</span>
<a name="l00231"></a>00231 <span class="comment">                    // unsigned int vertexIndex;</span>
<a name="l00232"></a>00232 <span class="comment">                    // unsigned short boneIndex;</span>
<a name="l00233"></a>00233 <span class="comment">                    // float weight;</span>
<a name="l00234"></a>00234 <span class="comment">            M_GEOMETRY          = 0x5000, // NB this chunk is embedded within M_MESH and M_SUBMESH</span>
<a name="l00235"></a>00235 <span class="comment">            */</span>
<a name="l00236"></a>00236                 <span class="comment">// unsigned int vertexCount</span>
<a name="l00237"></a>00237                 <span class="comment">// float* pVertices (x, y, z order x numVertices)</span>
<a name="l00238"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a05282af650e923e0cbff1bc35e19eb21">00238</a>                 <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4a05282af650e923e0cbff1bc35e19eb21">M_GEOMETRY_NORMALS</a> = 0x5100,    <span class="comment">//(Optional)</span>
<a name="l00239"></a>00239                     <span class="comment">// float* pNormals (x, y, z order x numVertices)</span>
<a name="l00240"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4ae55f61d76f1149a9bed5c32711d404ab">00240</a>                 <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4ae55f61d76f1149a9bed5c32711d404ab">M_GEOMETRY_COLOURS</a> = 0x5200,    <span class="comment">//(Optional)</span>
<a name="l00241"></a>00241                     <span class="comment">// unsigned long* pColours (RGBA 8888 format x numVertices)</span>
<a name="l00242"></a><a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4aec8563534d08ae9b4d15d04e5c999c1d">00242</a>                 <a class="code" href="group__Resources.html#gga7b904fc5463a8ef1e61f6de39b603fc4aec8563534d08ae9b4d15d04e5c999c1d">M_GEOMETRY_TEXCOORDS</a> = 0x5300    <span class="comment">//(Optional, REPEATABLE, each one adds an extra set)</span>
<a name="l00243"></a>00243                     <span class="comment">// unsigned short dimensions    (1 for 1D, 2 for 2D, 3 for 3D)</span>
<a name="l00244"></a>00244                     <span class="comment">// float* pTexCoords  (u [v] [w] order, dimensions x numVertices)</span>
<a name="l00245"></a>00245             <span class="comment">/*</span>
<a name="l00246"></a>00246 <span class="comment">            M_MESH_SKELETON_LINK = 0x6000,</span>
<a name="l00247"></a>00247 <span class="comment">                // Optional link to skeleton</span>
<a name="l00248"></a>00248 <span class="comment">                // char* skeletonName           : name of .skeleton to use</span>
<a name="l00249"></a>00249 <span class="comment">            M_MESH_BONE_ASSIGNMENT = 0x7000,</span>
<a name="l00250"></a>00250 <span class="comment">                // Optional bone weights (repeating section)</span>
<a name="l00251"></a>00251 <span class="comment">                // unsigned int vertexIndex;</span>
<a name="l00252"></a>00252 <span class="comment">                // unsigned short boneIndex;</span>
<a name="l00253"></a>00253 <span class="comment">                // float weight;</span>
<a name="l00254"></a>00254 <span class="comment">            M_MESH_LOD = 0x8000,</span>
<a name="l00255"></a>00255 <span class="comment">                // Optional LOD information</span>
<a name="l00256"></a>00256 <span class="comment">                // unsigned short numLevels;</span>
<a name="l00257"></a>00257 <span class="comment">                // bool manual;  (true for manual alternate meshes, false for generated)</span>
<a name="l00258"></a>00258 <span class="comment">                M_MESH_LOD_USAGE = 0x8100,</span>
<a name="l00259"></a>00259 <span class="comment">                // Repeating section, ordered in increasing depth</span>
<a name="l00260"></a>00260 <span class="comment">                // NB LOD 0 (full detail from 0 depth) is omitted</span>
<a name="l00261"></a>00261 <span class="comment">                // float fromSquaredDepth;</span>
<a name="l00262"></a>00262 <span class="comment">                    M_MESH_LOD_MANUAL = 0x8110,</span>
<a name="l00263"></a>00263 <span class="comment">                    // Required if M_MESH_LOD section manual = true</span>
<a name="l00264"></a>00264 <span class="comment">                    // String manualMeshName;</span>
<a name="l00265"></a>00265 <span class="comment">                    M_MESH_LOD_GENERATED = 0x8120,</span>
<a name="l00266"></a>00266 <span class="comment">                    // Required if M_MESH_LOD section manual = false</span>
<a name="l00267"></a>00267 <span class="comment">                    // Repeating section (1 per submesh)</span>
<a name="l00268"></a>00268 <span class="comment">                    // unsigned int indexCount;</span>
<a name="l00269"></a>00269 <span class="comment">                    // bool indexes32Bit</span>
<a name="l00270"></a>00270 <span class="comment">                    // unsigned short* faceIndexes;  (indexCount)</span>
<a name="l00271"></a>00271 <span class="comment">                    // OR</span>
<a name="l00272"></a>00272 <span class="comment">                    // unsigned int* faceIndexes;  (indexCount)</span>
<a name="l00273"></a>00273 <span class="comment">            M_MESH_BOUNDS = 0x9000</span>
<a name="l00274"></a>00274 <span class="comment">                // float minx, miny, minz</span>
<a name="l00275"></a>00275 <span class="comment">                // float maxx, maxy, maxz</span>
<a name="l00276"></a>00276 <span class="comment">                // float radius</span>
<a name="l00277"></a>00277 <span class="comment"></span>
<a name="l00278"></a>00278 <span class="comment">            // Added By DrEvil</span>
<a name="l00279"></a>00279 <span class="comment">            // optional chunk that contains a table of submesh indexes and the names of</span>
<a name="l00280"></a>00280 <span class="comment">            // the sub-meshes.</span>
<a name="l00281"></a>00281 <span class="comment">            M_SUBMESH_NAME_TABLE,</span>
<a name="l00282"></a>00282 <span class="comment">                // Subchunks of the name table. Each chunk contains an index &amp; string</span>
<a name="l00283"></a>00283 <span class="comment">                M_SUBMESH_NAME_TABLE_ELEMENT,</span>
<a name="l00284"></a>00284 <span class="comment">                    // short index</span>
<a name="l00285"></a>00285 <span class="comment">                    // char* name</span>
<a name="l00286"></a>00286 <span class="comment"></span>
<a name="l00287"></a>00287 <span class="comment">    */</span>
<a name="l00288"></a>00288     };
<a name="l00292"></a>00292 } <span class="comment">// namespace</span>
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 
<a name="l00295"></a>00295 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
